C*****************************************
       program extracter
C*****************************************
       implicit none

       include 'common.fi'

       parameter (CD=11)
       parameter (CD2=11)
       dimension gbd(CD,CD,CD,CD2,4*CD2)
       dimension e1(3), e2(3)
       dimension gg1(3,3), gg2(3,3), dg(3,3)
       dimension so1(3,3), so2(3,3), sa(2), so2t(3,3)
       dimension ax(3)

       integer point
       real minmrd, interval

       logical first
       integer xjk,i1,i2

!  CODE::
       write(6,*) '=============================================='
       write(6,*) ' PROGRAM EXTRACTS ENERGY OR POPULATION VALUES'
       write(6,*) ' FROM GBCD OR ENERGY DATA IN THE STANDARD '
       write(6,*) ' FORMAT AT SPECIFIC POINTS SPECIFIED BY THE '
       write(6,*) ' MISORIENTATION AXIS, ANGLE OF ROTATION,  '
       write(6,*) ' AND GRAIN BOUNDARY NORMAL VECTOR '
       write(6,*)
       write(6,*) ' DEVELOPED BY THE CMU MRSEC'
       write(6,*) '  version 09/10/2008'
       write(6,*) '  rohrer@cmu.edu'	   
       write(6,*) '=============================================='
	   
	   
       degrad = 180./3.14159
       pi = 4.0*atan(1.0)
       eps = 1.e-6   !  used for testing angles
       HCD = 90.0

       open(21, file='input.txt', status='old')
       read(21,*) keyword
       point = index(keyword,'.') - 1
       read(21,*) tempword
       read(21,*) msym

	   write(6,*)'extracting data from: ', keyword
	   
c  The statement calls the subroutine that contains the symmetry operators.  The variable
c  msym, read from the input file, specifies the symmetry (1 = tetragonal, 2 = hexagonal, 
c  3 = subic, 4 = trigonal), O is a matrix containing the operators, and nsymm is the 
c  number of symmetry operators.  The routine returns O and nsymm.

       call get_symop (msym, O, nsymm)

c  This part is to zero the grain boundary character distribution matrix		
       do i=1,CD
          do j=1,CD
             do k=1,CD
                do ii=1,CD2
                   do jj=1,4*CD2
                      gbd(i,j,k,ii,jj)=0.0
                   enddo
                enddo
             enddo
          enddo
       enddo	

c  the data is read from the file specified in the input file into matrix gbd

       open (33, file=keyword, status='old')
!	   read (33, *)tempword
       do i=1,CD
          do j=1,CD
             do k=1,CD
                do ii=1,CD2
                   do jj=1,4*CD2
                      read (33,*) gbd(i,j,k,ii,jj)
                   enddo
                enddo
             enddo
          enddo
       enddo
       close (33)
	      
	   open (34, file='out.txt', status='unknown')
c      read the input file	
       read (21,*) tempword
       read (21,*) numplots
       
       read (21,*)tempword9, tempword9, tempword9, tempword9, 
     &            tempword9, tempword9, tempword9
	 
	 
       plot = 0
       do plot=1,numplots
c       the axis and angle are read from the input file

          first = .true.

 20       format(3f8.3,f8.1, 3f8.3)
	      read(21,20)ax(1),ax(2),ax(3),ang,n_plot(1),n_plot(2),n_plot(3)

c       the axis and angle, input as miller indices and degrees of rotation, 
c       is converted to a unit vector and rotation in radians

          ss=sqrt(ax(1)*ax(1)+ax(2)*ax(2)+ax(3)*ax(3))
          ax(1)=ax(1)/ss
          ax(2)=ax(2)/ss
          ax(3)=ax(3)/ss
          ang=ang*(pi/180.0)

c       this converts the axis and angle values to a g matrix
		
          call AAToG (ax, ang, g)

	        summrd=0.0
            maxmrd = 0.0
            minmrd = 1.e+36  ! large value

c               this assigns the normal of interest to n1
				sum=0.0
				n1(1)=n_plot(1)
				n1(2)=n_plot(2)
				n1(3)=n_plot(3)
c		        this call returns the transpose of g
				call trans (g, gt)
c		        this call rotates n by the transposed matrix, and names it n2
                call MToV (gt, n1, n2)
				
				ct=0
		  
c               in this next loop, n1 and n2 are hit with all the symmetry operators, then
c               the bin corresponding to each vector is queried.  Values read from all of
c               indistinguishable bins are then averaged to yeild a value for this 
c               this specific orientation.
		  
		        do ii_plot=1,nsymm
				  do jj_plot=1,nsymm	 
				  call symop (O, ii_plot, so1)
c                 this rotates n1 by the first, non-transposed operator
				  call MToV (so1, n1, nf)  
c                 get the second symmetry operator
                  call symop (O, jj_plot, so2)
c                 this returns the transpose of the second symmetry operator
				  call trans (so2,so2t)
c		          these steps determine the misorientation, then find the
c                 equivalent Euler angles
				  call MToM (g, so2t, gg1)
				  call MToM (so1, gg1, dg)
				  call GToE (dg, mort)
c		          We only consider those misorientations in the domain where
c                 phi1, cap_phi, and phi2 are between zero and 90
			      if (mort(1).lt.(pi*0.5+eps) .and. 
     &                       mort(2).lt.(pi*0.5+eps) .and. 
     &                       mort(3).lt.(pi*0.5+eps) ) then
c                  this returns the azimuthal (0 to 90) and in-plane (0 to 360) angles	 
	               call VToAngles (nf, sa)
c                  these steps find the bin that corresponds to five parameters (mort(3) and sa(2))			
				   c1=int(float(CD)*2.0*mort(1)/pi)+1
				   c2=int(float(CD)*cos(mort(2)))+1
				   c3=int(float(CD)*2.0*mort(3)/pi)+1
				   c4=int(float(CD2)*cos(sa(1)))+1
				   c5=int(float(4*CD2)*sa(2)/(pi*2.0))+1
				   if (c1.eq.CD+1) c1=CD
				   if (c2.eq.CD+1) c2=CD
				   if (c3.eq.CD+1) c3=CD
				   if (c4.eq.CD2+1) c4=CD2
				   if (c4.eq.0) c4=1
				   if (c5.eq.4*CD2+1) c5=4*CD2
c			       here, we add the value in this bin to a total and increment the
c                  counter (ct) so it can be properly averaged later
				   sum=sum+gbd(c1,c2,c3,c4,c5)
				   ct=ct+1
			      endif
			
c                 the next section of code repeats what is done above, except that
c                 the crystals have been exchanged, so we are considering the interface
c                 orientation in the reference frame of the second crystal			
			
				  call MToV (so1, n2, nf)
				  call trans (g, gt)
				  call MToM (gt, so2, gg2)
				  call MToM (so1, gg2, dg)
				  call GToE (dg, mort)
			      if (mort(1).lt.(pi*0.5+eps) .and. 
     &                       mort(2).lt.(pi*0.5+eps) .and. 
     &                       mort(3).lt.(pi*0.5+eps) ) then
				   call VToAngles (nf, sa)
				   c1=int(float(CD)*2.0*mort(1)/pi)+1
				   c2=int(float(CD)*cos(mort(2)))+1
				   c3=int(float(CD)*2.0*mort(3)/pi)+1
				   c4=int(float(CD2)*cos(sa(1)))+1
				   c5=int(float(4*CD2)*sa(2)/(pi*2.0))+1
				   if (c1.eq.CD+1) c1=CD
				   if (c2.eq.CD+1) c2=CD
				   if (c3.eq.CD+1) c3=CD
				   if (c4.eq.CD2+1) c4=CD2
				   if (c4.eq.0) c4=1
				   if (c5.eq.4*CD2+1) c5=4*CD2
				   sum=sum+gbd(c1,c2,c3,c4,c5)
				   ct=ct+1
			      endif
				 enddo   !jj_plot loop
		        enddo   !ii_plot loop
         
		 
c        this line computes the average from all of the indistinuishable bins		 
		 
                 amrd=sum/float(ct)

 201         format(2f11.3)
             write(34,201) ang*(180/pi), amrd			 
      enddo

      close (21)
      close (34)
      end
